using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using System.Security;
using System.Security.Cryptography;

namespace ExtendedWebBrowser2
{
  partial class BrowserControl : UserControl
  {
    public BrowserControl()
    {
      InitializeComponent();
      _browser = new ExtendedWebBrowser();
      _browser.Dock = DockStyle.Fill;
      _browser.DownloadComplete += new EventHandler(_browser_DownloadComplete);
      _browser.Navigated += new WebBrowserNavigatedEventHandler(_browser_Navigated);
      _browser.StartNewWindow += new EventHandler<BrowserExtendedNavigatingEventArgs>(_browser_StartNewWindow);
      _browser.DocumentCompleted += new WebBrowserDocumentCompletedEventHandler(_browser_DocumentCompleted);
      _browser.ScriptErrorsSuppressed = true;
      //_browser.Navigate("http://www.networksolutions.com");
      this.containerPanel.Controls.Add(_browser);
        this.addressTextBox.Text = "http://wwww.networksolutions.com";
      
      // Make the magenta color transparent on the go button
      Bitmap bmp = (Bitmap)goButton.Image;
      bmp.MakeTransparent(Color.Magenta);


      this.tmrSearch.Start();


    }


    void _browser_DownloadComplete(object sender, EventArgs e)
    {
      // Check wheter the document is available (it should be)
      if (this.WebBrowser.Document != null)
      {
        // Subscribe to the Error event
        this.WebBrowser.Document.Window.Error += new HtmlElementErrorEventHandler(Window_Error);
        UpdateAddressBox();
      }
    }

    void Window_Error(object sender, HtmlElementErrorEventArgs e)
    {
      // We got a script error, record it
      ScriptErrorManager.Instance.RegisterScriptError(e.Url, e.Description, e.LineNumber);
      // Let the browser know we handled this error.
      e.Handled = true;
    }

    void _browser_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
    {
      UpdateAddressBox();
    }

    // Updates the addres box with the actual URL of the document
    private void UpdateAddressBox()
    {
      string urlString = this.WebBrowser.Document.Url.ToString();
      if (!urlString.Equals(this.addressTextBox.Text, StringComparison.InvariantCultureIgnoreCase))
      {
        this.addressTextBox.Text = urlString;
      }
    }

    void _browser_StartNewWindow(object sender, BrowserExtendedNavigatingEventArgs e)
    {
      // Here we do the pop-up blocker work

      // Note that in Windows 2000 or lower this event will fire, but the
      // event arguments will not contain any useful information
      // for blocking pop-ups.

      // There are 4 filter levels.
      // None: Allow all pop-ups
      // Low: Allow pop-ups from secure sites
      // Medium: Block most pop-ups
      // High: Block all pop-ups (Use Ctrl to override)

      // We need the instance of the main form, because this holds the instance
      // to the WindowManager.
      MainForm mf = GetMainFormFromControl(sender as Control);
      if (mf == null)
        return;

      // Allow a popup when there is no information available or when the Ctrl key is pressed
      bool allowPopup = (e.NavigationContext == UrlContext.None) || ((e.NavigationContext & UrlContext.OverrideKey) == UrlContext.OverrideKey);

      if (!allowPopup)
      {
        // Give None, Low & Medium still a chance.
        switch (SettingsHelper.Current.FilterLevel)
        {
          case PopupBlockerFilterLevel.None:
            allowPopup = true;
            break;
          case PopupBlockerFilterLevel.Low:
            // See if this is a secure site
            if (this.WebBrowser.EncryptionLevel != WebBrowserEncryptionLevel.Insecure)
              allowPopup = true;
            else
              // Not a secure site, handle this like the medium filter
              goto case PopupBlockerFilterLevel.Medium;
            break;
          case PopupBlockerFilterLevel.Medium:
            // This is the most dificult one.
            // Only when the user first inited and the new window is user inited
            if ((e.NavigationContext & UrlContext.UserFirstInited) == UrlContext.UserFirstInited && (e.NavigationContext & UrlContext.UserInited) == UrlContext.UserInited)
              allowPopup = true;
            break;
        }
      }

      if (allowPopup)
      {
        // Check wheter it's a HTML dialog box. If so, allow the popup but do not open a new tab
        if (!((e.NavigationContext & UrlContext.HtmlDialog) == UrlContext.HtmlDialog))
        {
          ExtendedWebBrowser ewb = mf.WindowManager.New(false);
          // The (in)famous application object
          e.AutomationObject = ewb.Application;
        }
      }
      else
        // Here you could notify the user that the pop-up was blocked
        e.Cancel = true;
      
    }

    void _browser_Navigated(object sender, WebBrowserNavigatedEventArgs e)
    {
      UpdateAddressBox();
    }

    private ExtendedWebBrowser _browser;
    // Allows other code to obtain a reference to the extended web browser component
    public ExtendedWebBrowser WebBrowser
    {
      get { return _browser; }
    }

    // Used for the go button
    private void goButton_Click(object sender, EventArgs e)
    {
      Navigate();
    }

    // Navigate to the typed address
    private void Navigate()
    {
      this.WebBrowser.Navigate(this.addressTextBox.Text);
    }

    // Used for obtaining the MainForm from a control
    private static MainForm GetMainFormFromControl(Control control)
    {
      while (control != null)
      {
        if (control is MainForm)
          break;
        control = control.Parent;
      }
      return control as MainForm;
    }

    // Used for catching the Enter key in the textbox
    private void addressTextBox_KeyUp(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.Enter)
      {
        e.Handled = true;
        Navigate();
      }
    }


      // From:
      // http://www.c-sharpcorner.com/UploadFile/mahesh/RandomNumber11232005010428AM/RandomNumber.aspx
      private string RandomString(int size, bool lowerCase)
      {
          StringBuilder builder = new StringBuilder();
          Random random = new Random();
          char ch;
          for (int i = 0; i < size; i++)
          {
              ch = Convert.ToChar(Convert.ToInt32(Math.Floor(26 * random.NextDouble() + 65)));
              builder.Append(ch);
          }
          if (lowerCase)
              return builder.ToString().ToLower();
          return builder.ToString();
      }

      private Random m_quick;

      private void tmrSearch_Tick(object sender, EventArgs e)
      {
          Random r = new Random();
          this.tmrSearch.Interval = r.Next(5000, 15000);

          try
          {
              if (this.WebBrowser.Url.ToString().StartsWith("http://www.networksolutions"))
              {
                  // good to go :) hehehe
                  // Fill in a shitload of searches :)

                  HtmlDocument doc;
                  doc = this.WebBrowser.Document;
                  string kw3 = doc.All["kw3"].InnerText;
                  if (kw3 == null)
                      kw3 = "";

                  if (kw3.Trim() == string.Empty || kw3 == null)
                  {
                      // Fill in a bunch of shit.
                      StringBuilder sbShit = new StringBuilder();
                      m_quick = new Quick((DateTime.Now.Second + 1) * DateTime.Now.Millisecond * DateTime.Now.Hour );
                      for (int i = 0; i < 10; i++)
                      {
                          sbShit.AppendLine( RandomString(m_quick.Next(4, 53), false));
                      }

                      doc.All["kw3"].InnerText = sbShit.ToString();

                  }
                  else
                  {
                      doc.All["kw3"].InnerText = "networksolutionssucksdonkeyballs\r\n" + doc.All["kw3"].InnerText;
                  }

                  try
                  {
                      // select to search everything :)
                      HtmlElement el = this.WebBrowser.Document.All["selectAll"];
                      object obj = el.DomElement;
                      System.Reflection.MethodInfo mi = obj.GetType().GetMethod("click");
                      mi.Invoke(obj, new object[0]);
                  }
                  catch
                  {
                  }

                  try
                  {
                      // the search page
                      HtmlElement el = this.WebBrowser.Document.All["method-searchFromSearchResults"];
                      object obj = el.DomElement;
                      System.Reflection.MethodInfo mi = obj.GetType().GetMethod("click");
                      mi.Invoke(obj, new object[0]);
                      // hehe
                  }
                  catch
                  {
                      try
                      {
                          // the home page
                          HtmlElement el = this.WebBrowser.Document.All["go"];
                          object obj = el.DomElement;
                          System.Reflection.MethodInfo mi = obj.GetType().GetMethod("click");
                          mi.Invoke(obj, new object[0]);
                          // hehe
                      }
                      catch
                      {
                      }
                  }




              }
          }
          catch
          {
          }
      }

  }


  // from: http://www.c-sharpcorner.com/UploadFile/rmcochran/random07172006175425PM/random.aspx
  public abstract class RandomBase : Random
  {

      #region Constructors

      public RandomBase() { }

      public RandomBase(int seed) : base(seed) { }

      #endregion

      #region Methods

      protected int GetBaseNextInt32()
      {

          return base.Next();

      }

      protected uint GetBaseNextUInt32()
      {

          return ConvertToUInt32(base.Next());

      }

      protected double GetBaseNextDouble()
      {

          return base.NextDouble();

      }

      #endregion

      #region Overrides

      public abstract override int Next();

      public override int Next(int maxValue)
      {

          return Next(0, maxValue);

      }

      public override int Next(int minValue, int maxValue)
      {

          return Convert.ToInt32((maxValue - minValue) * Sample() + minValue);

      }

      public override double NextDouble()
      {

          return Sample();

      }

      public override void NextBytes(byte[] buffer)
      {

          int i, j, tmp;

          // fill the part of the buffer that can be covered by full Int32s

          for (i = 0; i < buffer.Length - 4; i += 4)
          {

              tmp = Next();

              buffer[i] = Convert.ToByte(tmp & 0x000000FF);

              buffer[i + 1] = Convert.ToByte((tmp & 0x0000FF00) >> 8);

              buffer[i + 2] = Convert.ToByte((tmp & 0x00FF0000) >> 16);

              buffer[i + 3] = Convert.ToByte((tmp & 0xFF000000) >> 24);

          }

          tmp = Next();

          // fill the rest of the buffer

          for (j = 0; j < buffer.Length % 4; j++)
          {

              buffer[i + j] = Convert.ToByte(((tmp & (0x000000FF << (8 * j))) >> (8 * j)));

          }

      }

      protected override double Sample()
      {

          // generates a random number on [0,1) 

          return Convert.ToDouble(Next()) / 2147483648.0; // divided by 2^31 (Int32 absolute value)

      }

      #endregion



      #region Utility Methods

      protected static UInt32 ConvertToUInt32(Int32 value)
      {

          return BitConverter.ToUInt32(BitConverter.GetBytes(value), 0);

      }

      protected static Int32 ConvertToInt32(UInt32 value)
      {

          return BitConverter.ToInt32(BitConverter.GetBytes(value), 0);

      }

      protected static Int32 ConvertToInt32(UInt64 value)
      {

          return BitConverter.ToInt32(BitConverter.GetBytes(value & 0x000000007fffffff), 0);

      }

      #endregion

  }

  public class Quick : RandomBase
  {

      #region Constructors

      public Quick() : this(Convert.ToInt32(DateTime.Now.Ticks & 0x000000007FFFFFFF)) { }

      public Quick(int seed)

          : base(seed)
      {

          i = Convert.ToUInt64(GetBaseNextInt32());

      }

      #endregion

      #region Member Variables

      private static readonly uint a = 1099087573;

      private ulong i;

      #endregion

      #region Methods

      public override int Next()
      {

          #region Execution

          i = a * i; // overflow occurs here!

          return ConvertToInt32(i);

          #endregion

      }

      #endregion

  }

}
